// AEncodeProperties.cpp: implementation of the AEncodeProperties class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(STRICT)
#define STRICT
#endif // !defined(STRICT)

#include <windows.h>
#include <windowsx.h>
#include <shlobj.h>
#include <assert.h>

#include "resource.h"
#include "BladeMP3EncDLL.h"
#include "AOut.h"
#include "AEncodeProperties.h"

const unsigned int AEncodeProperties::the_Bitrates[18] = {320, 256, 224, 192, 160, 144, 128, 112, 96, 80, 64, 56, 48, 40, 32, 24, 16, 8 };
const unsigned int AEncodeProperties::the_MPEG1_Bitrates[14] = {320, 256, 224, 192, 160, 128, 112, 96, 80, 64, 56, 48, 40, 32 };
const unsigned int AEncodeProperties::the_MPEG2_Bitrates[14] = {160, 144, 128, 112, 96, 80, 64, 56, 48, 40, 32, 24, 16, 8};
const unsigned int AEncodeProperties::the_ChannelModes[] = {BE_MP3_MODE_MONO, BE_MP3_MODE_STEREO, BE_MP3_MODE_JSTEREO, BE_MP3_MODE_DUALCHANNEL };
//const char         AEncodeProperties::the_Presets[][13] = {"None", "CD", "Studio", "Hi-Fi", "Phone", "Voice", "Radio", "Tape", "FM", "AM", "SW"};
const LAME_QUALTIY_PRESET AEncodeProperties::the_Presets[] = {LQP_NOPRESET, LQP_NORMAL_QUALITY, LQP_LOW_QUALITY, LQP_HIGH_QUALITY, LQP_VOICE_QUALITY, LQP_PHONE, LQP_SW, LQP_AM, LQP_FM, LQP_VOICE, LQP_RADIO, LQP_TAPE, LQP_HIFI, LQP_CD, LQP_STUDIO};
const unsigned int AEncodeProperties::the_SamplingFreqs[9] = { 48000, 44100, 32000, 24000, 22050, 16000, 12000, 11025, 8000 };

static UINT CALLBACK DLLFindCallback(
  HWND hdlg,      // handle to child dialog box
  UINT uiMsg,     // message identifier
  WPARAM wParam,  // message parameter
  LPARAM lParam   // message parameter
  )
{
	UINT result = 0;

	switch (uiMsg)
	{
		case WM_NOTIFY:
			OFNOTIFY * info = (OFNOTIFY *)lParam;
			if (info->hdr.code == CDN_FILEOK)
			{
				result = 1; // by default we don't accept the file

				// Check if the selected file is a valid DLL with all the required functions
				ALameDLL * tstFile = new ALameDLL;
				if (tstFile != NULL)
				{
					if (tstFile->Load(info->lpOFN->lpstrFile))
					{
						result = 0;
					}

					delete tstFile;
				}

				if (result == 1)
				{
					TCHAR output[250];
					::LoadString(AOut::GetInstance(),IDS_STRING_DLL_UNRECOGNIZED,output,250);
					MessageBox( hdlg, output, "Winamp MP3 Output",MB_OK);
					SetWindowLong(hdlg, DWL_MSGRESULT , -100);
				}
			}
	}

	return result;
}

static int CALLBACK BrowseFolderCallbackroc(
    HWND hwnd,
    UINT uMsg,
    LPARAM lParam,
    LPARAM lpData
    )
{
	AEncodeProperties * the_prop;
	the_prop = (AEncodeProperties *) lpData;


	if (uMsg == BFFM_INITIALIZED)
	{
//		char FolderName[MAX_PATH];
//		SHGetPathFromIDList((LPITEMIDLIST) lParam,FolderName);
//ADbg tst;
//tst.OutPut("init folder to %s ",the_prop->GetOutputDirectory());
//		CreateFile();
		::SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, (LPARAM)the_prop->GetOutputDirectory());
	}/* else if (uMsg == BFFM_SELCHANGED)
	{
		// verify that the folder is writable
//		::SendMessage(hwnd, BFFM_ENABLEOK, 0, (LPARAM)0); // disable
		char FolderName[MAX_PATH];
		SHGetPathFromIDList((LPITEMIDLIST) lParam, FolderName);
		
//		if (CreateFile(FolderName,STANDARD_RIGHTS_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL) == INVALID_HANDLE_VALUE)
		if ((GetFileAttributes(FolderName) & FILE_ATTRIBUTE_DIRECTORY) != 0)
			::SendMessage(hwnd, BFFM_ENABLEOK, 0, (LPARAM)1); // enable
		else
			::SendMessage(hwnd, BFFM_ENABLEOK, 0, (LPARAM)0); // disable
//ADbg tst;
//tst.OutPut("change folder to %s ",FolderName);
	}*/

	return 0;
}
#ifdef OLD
#endif // OLD

static BOOL CALLBACK ConfigProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
  )
{
	BOOL bResult;

	switch (uMsg) {
		case WM_COMMAND:
			UINT command;
			command = GET_WM_COMMAND_ID(wParam, lParam);
            if (IDOK == command)
            {
				// save parameters
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

				if (the_prop != NULL)
					the_prop->UpdateValueFromDlg(hwndDlg);

				RemoveProp(hwndDlg, "AEncodeProperties-Config");

                EndDialog(hwndDlg, (IDOK == command));
            } else if (IDCANCEL == command)
            {
				RemoveProp(hwndDlg, "AEncodeProperties-Config");
                EndDialog(hwndDlg, (IDOK == command));
            } else if (IDC_FIND_DLL == command)
			{
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

				if (the_prop != NULL)
				{
					OPENFILENAME file;

					memset(&file, 0, sizeof(file));
					file.lStructSize = sizeof(file); 
					file.hwndOwner  = hwndDlg;
					file.Flags = OFN_FILEMUSTEXIST | OFN_NODEREFERENCELINKS | OFN_ENABLEHOOK | OFN_EXPLORER ;
///				file.lpstrFile = AOut::the_AOut->DllLocation;
					file.lpstrFile = the_prop->GetDllLocation();
					file.lpstrFilter = "Lame DLL (lame_enc.dll)\0LAME_ENC.DLL\0DLL (*.dll)\0*.DLL\0All (*.*)\0*.*\0";
					file.nFilterIndex = 1;
					file.nMaxFile  = the_prop->GetDllLocationSize();
					file.lpfnHook  = DLLFindCallback; // use to validate the DLL chosen

					GetOpenFileName(&file);
					// use this filename if necessary

//				AOut::the_AOut->the_Debug.OutPut(AOut::DllLocation);
				}
			} else if (IDC_BUTTON_OUTPUT == command)
			{
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");

//				ITEMIDLIST previous;
//				previous.

				BROWSEINFO info;
				memset(&info,0,sizeof(info));

				char FolderName[MAX_PATH];
/*				wsprintf( FolderName, the_prop->GetOutputDirectory());
ADbg tst;
tst.OutPut("Folder = %s",FolderName);

*/
				info.hwndOwner = hwndDlg;
				info.pszDisplayName  = FolderName;
				info.lpfn = BrowseFolderCallbackroc;
				info.lParam = (LPARAM) the_prop;

				TCHAR output[250];
				::LoadString(AOut::GetInstance(),IDS_STRING_DIR_SELECT,output,250);
				info.lpszTitle = output;

//				info.ulFlags = BIF_STATUSTEXT ;

/*				LPMALLOC pMalloc = NULL;
				SHGetMalloc(&pMalloc);

				LPITEMIDLIST pidlRoot = NULL;
//				SHGetFolderLocation(NULL,CSIDL_PERSONAL,NULL,0,&pidlRoot);
				SHGetSpecialFolderLocation(hwndDlg, CSIDL_PERSONAL,&pidlRoot);
				info.pidlRoot = pidlRoot;
*/
//tst.OutPut("Folder = %s",FolderName);
				ITEMIDLIST *item = SHBrowseForFolder(&info);
ADbg tst;
tst.OutPut("Folder = %s",FolderName);

/*
				if(pidlRoot)
				{
					pMalloc->Free(pidlRoot);
				}
				pMalloc->Release();
*/
    			if (item != NULL)
				{
					SHGetPathFromIDList(item,the_prop->GetOutputDirectory());
//					wsprintf(the_prop->OutputDir,FolderName);
tst.OutPut("Folder = %s",the_prop->GetOutputDirectory());
				}
else tst.OutPut("Folder not selected (%s)",FolderName);

#ifdef OLD
				OPENFILENAME file;

				memset(&file, 0, sizeof(file));
				file.lStructSize = sizeof(file); 
				file.hwndOwner  = hwndDlg;
				file.Flags = OFN_FILEMUSTEXIST | OFN_NODEREFERENCELINKS | OFN_ENABLEHOOK | OFN_EXPLORER ;
//				file.lpstrFile = the_prop->GetDllLocation();
//				file.lpstrFile = the_prop->GetOutputDirectory();
				file.lpstrInitialDir = the_prop->GetOutputDirectory();
//				file.lpstrFilter = "Lame DLL (lame_enc.dll)\0LAME_ENC.DLL\0DLL (*.dll)\0*.DLL\0All (*.*)\0*.*\0";
				file.lpstrFilter = "Dirs \0.*\0";
//				file.nFilterIndex = 1;
				file.nMaxFile  = the_prop->GetDllLocationSize();
				file.lpfnHook  = DLLFindCallback; // use to validate the DLL chosen
//				file.Flags = OFN_ENABLESIZING | OFN_NOREADONLYRETURN | OFN_HIDEREADONLY;
				file.Flags = OFN_NOREADONLYRETURN | OFN_HIDEREADONLY;

				TCHAR output[250];
				::LoadString(AOut::GetInstance(),IDS_STRING_DIR_SELECT,output,250);
				file.lpstrTitle = output;

//				GetOpenFileName(&file);
				GetSaveFileName(&file);

#endif // OLD
//				SetProp(hwndDlg, "FolderName", the_prop->GetOutputDirectory());

			} else if (IDC_CHECK_VBR == command)
			{
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");
				if (the_prop != NULL)
				{
					bool tmp_bVBRused = (SendMessage(GetDlgItem( hwndDlg, IDC_CHECK_VBR), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
					if (tmp_bVBRused)
					{
						AEncodeProperties::DisplayVbrOptions(hwndDlg, true);
					}
					else
					{
						AEncodeProperties::DisplayVbrOptions(hwndDlg, false);
					}
//					the_prop->SetVBRUseMode(bVBRused);
				}
			} else if (IDC_CHECK_RESAMPLE == command)
			{
				bool tmp_bResampleUsed = (SendMessage(GetDlgItem( hwndDlg, IDC_CHECK_RESAMPLE), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
				if (tmp_bResampleUsed)
				{
//					ShowWindow(GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ),SW_SHOW);
					::EnableWindow(::GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ), TRUE);
				}
				else
				{
//					ShowWindow(GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ),SW_HIDE);
					::EnableWindow(::GetDlgItem(hwndDlg,IDC_COMBO_SAMPLEFREQ), FALSE);
				}
			} else if (IDC_SLIDER_QUALITY == command)
			{
				ADbg tst;
				tst.OutPut("cmd IDC_SLIDER_QUALITY");
			}
			
			
            bResult = FALSE;
			break;
		case WM_INITDIALOG:
			AEncodeProperties * the_prop;

			the_prop = (AEncodeProperties *) lParam;

			the_prop->InitConfigDlg(hwndDlg);

			SetProp(hwndDlg, "AEncodeProperties-Config", the_prop);

			bResult = TRUE;
			break;
/*		case WM_NOTIFY:
			{
			ADbg tst;
			tst.OutPut("msg WM_NOTIFY");
			}
			break;*/
		case WM_HSCROLL:
			// check if it's the Quality slider
			if ((HWND)lParam == GetDlgItem(hwndDlg,IDC_SLIDER_QUALITY))
			{
//				ADbg tst;
//				tst.OutPut("msg WM_NOTIFY %d/%d / %08X / %08X / %08X",LOWORD(wParam),HIWORD(wParam),lParam,hwndDlg,GetDlgItem(hwndDlg,IDC_SLIDER_QUALITY));
				
				AEncodeProperties * the_prop;
				the_prop = (AEncodeProperties *) GetProp(hwndDlg, "AEncodeProperties-Config");
				if (the_prop != NULL)
				{
					UINT VbrQuality = SendMessage(GetDlgItem( hwndDlg, IDC_SLIDER_QUALITY), TBM_GETPOS, NULL, NULL);
					char tmp[2];
					wsprintf(tmp,"%d",VbrQuality);
					SetWindowText(GetDlgItem( hwndDlg, IDC_CONFIG_QUALITY), tmp);
				}
			}
			break;
		default:
			bResult = FALSE; // will be treated by DefWindowProc
	}
	return bResult;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

const char * AEncodeProperties::GetChannelModeString(int a_channelID) const
{
	assert(nChannelIndex < sizeof(the_ChannelModes));

	switch (a_channelID) {
		case 0:
			return "Mono";
		case 1:
			return "Stereo";
		case 2:
			return "Joint-stereo";
		default:
			return "Dual Channel";
	}
}

const int AEncodeProperties::GetBitrateString(char * string, int string_size, int a_bitrateID) const
{
	assert(a_bitrateID < sizeof(the_Bitrates));

	if (string != NULL)
		return wsprintf(string,"%d",the_Bitrates[a_bitrateID]);
	else
		return -1;
}

const unsigned int AEncodeProperties::GetChannelModeValue() const
{
	assert(nChannelIndex < sizeof(the_ChannelModes));

	return the_ChannelModes[nChannelIndex];
}

const unsigned int AEncodeProperties::GetBitrateValue() const
{
	assert(nMinBitrateIndex < sizeof(the_Bitrates));

	return the_Bitrates[nMinBitrateIndex];
}

inline const int AEncodeProperties::GetBitrateValueMPEG2(DWORD & bitrate) const
{
	int i;

	for (i=0;i<sizeof(the_MPEG2_Bitrates)/sizeof(unsigned int);i++)
	{
		if (the_MPEG2_Bitrates[i] == the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG2_Bitrates[i];
			return 0;
		}
		else if (the_MPEG2_Bitrates[i] < the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG2_Bitrates[i];
			return -1;
		}
	}
	
	bitrate = 160;
	return -1;
}

inline const int AEncodeProperties::GetBitrateValueMPEG1(DWORD & bitrate) const
{
	int i;

	for (i=sizeof(the_MPEG1_Bitrates)/sizeof(unsigned int)-1;i>=0;i--)
	{
		if (the_MPEG1_Bitrates[i] == the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG1_Bitrates[i];
			return 0;
		}
		else if (the_MPEG1_Bitrates[i] > the_Bitrates[nMinBitrateIndex])
		{
			bitrate = the_MPEG1_Bitrates[i];
			return 1;
		}
	}
	
	bitrate = 32;
	return 1;
}

const int AEncodeProperties::GetBitrateValue(DWORD & bitrate, const DWORD MPEG_Version) const
{
	assert((MPEG_Version == MPEG1) || (MPEG_Version == MPEG2));
	assert(nMinBitrateIndex < sizeof(the_Bitrates));

	if (MPEG_Version == MPEG2)
		return GetBitrateValueMPEG2(bitrate);
	else
		return GetBitrateValueMPEG1(bitrate);
}

const char * AEncodeProperties::GetPresetModeString(const int a_presetID) const
{
	assert(nPresetIndex < sizeof(the_Presets));

	switch (a_presetID) {
		case 1:
			return "Normal";
		case 2:
			return "Low";
		case 3:
			return "High";
		case 4:
			return "Voice";
		case 5:
			return "Phone";
		case 6:
			return "SW";
		case 7:
			return "AM";
		case 8:
			return "FM";
		case 9:
			return "Voice";
		case 10:
			return "Radio";
		case 11:
			return "Tape";
		case 12:
			return "Hi-Fi";
		case 13:
			return "CD";
		case 14:
			return "Studio";
		default:
			return "None";
	}
}

const LAME_QUALTIY_PRESET AEncodeProperties::GetPresetModeValue() const
{
	assert(nPresetIndex < sizeof(the_Presets));

	return the_Presets[nPresetIndex];
}

bool AEncodeProperties::Config(const HINSTANCE Hinstance, const HWND HwndParent)
{
	//WM_INITDIALOG ?

	// remember the instance to retreive strings
	hDllInstance = Hinstance;

	return (::DialogBoxParam(Hinstance, MAKEINTRESOURCE(IDD_CONFIG), HwndParent, ::ConfigProc, (LPARAM) this) == 1);
}

bool AEncodeProperties::InitConfigDlg(HWND HwndDlg)
{
	// get all the required strings
	TCHAR Version[5];
	LoadString(hDllInstance, IDS_STRING_VERSION, Version, 5);

	int i;

	// Check boxes if required
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_CRC),       BM_SETCHECK, GetCRCMode()      ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_ORIGINAL),  BM_SETCHECK, GetOriginalMode() ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_PRIVATE),   BM_SETCHECK, GetPrivateMode()  ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_COPYRIGHT), BM_SETCHECK, GetCopyrightMode()?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESERVOIR), BM_SETCHECK, !GetNoBiResMode() ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_VBR),       BM_SETCHECK, GetVBRUseMode()   ?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_XINGVBR),   BM_SETCHECK, GetXingFrameMode()?BST_CHECKED:BST_UNCHECKED, NULL);
	SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESAMPLE),  BM_SETCHECK, GetResampleMode() ?BST_CHECKED:BST_UNCHECKED, NULL);

	// Add required channel modes
	for (i=0;i<GetChannelLentgh();i++)
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS), CB_ADDSTRING, NULL, (LPARAM) GetChannelModeString(i));

	for (i=0;i<GetChannelLentgh();i++)
	{
		if (i == nChannelIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add all possible re-sampling freq
	char tmp[10];
	for (i=0;i<sizeof(the_SamplingFreqs)/sizeof(unsigned int);i++)
	{
		wsprintf(tmp, "%d", the_SamplingFreqs[i]);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_SETCURSEL, nSamplingFreqIndex, NULL);
	

	// Add required bitrates
	for (i=0;i<GetBitrateLentgh();i++)
	{
		GetBitrateString(tmp, 5, i);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}

	for (i=0;i<GetBitrateLentgh();i++)
	{
		if (i == nMinBitrateIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add bitrates to the VBR combo box too
	for (i=0;i<GetBitrateLentgh();i++)
	{
		GetBitrateString(tmp, 5, i);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}

	for (i=0;i<GetBitrateLentgh();i++)
	{
		if (i == nMaxBitrateIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	// Add VBR Quality
/*	wsprintf(tmp,"0 - high");
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_VBRQUALITY), CB_ADDSTRING, NULL, (LPARAM) tmp );

	for (i=1;i<9;i++) // from 0:high to 9:low
	{
		wsprintf(tmp,"%d",i);
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_VBRQUALITY), CB_ADDSTRING, NULL, (LPARAM) tmp );
	}

	wsprintf(tmp,"9 - low");
	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_VBRQUALITY), CB_ADDSTRING, NULL, (LPARAM) tmp );

	SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_VBRQUALITY), CB_SETCURSEL, VbrQuality, NULL);
*/
	SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_SETRANGE, TRUE, MAKELONG(0,9));

	wsprintf(tmp,"%d",VbrQuality);
	SetWindowText(GetDlgItem( HwndDlg, IDC_CONFIG_QUALITY), tmp);
	SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_SETPOS, TRUE, VbrQuality);
	
	
	// Display VBR settings if needed
	if (GetVBRUseMode())
	{
		AEncodeProperties;;DisplayVbrOptions(HwndDlg, true);
	}
	else
	{
		AEncodeProperties;;DisplayVbrOptions(HwndDlg, false);
	}

	// Display Resample settings if needed
	if (GetResampleMode())
	{
		::EnableWindow(::GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ), TRUE);
//		ShowWindow(GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ),SW_SHOW);
	}
	else
	{
		::EnableWindow(::GetDlgItem(HwndDlg,IDC_COMBO_SAMPLEFREQ), FALSE);
	}


	// Add presets
	for (i=0;i<GetPresetLentgh();i++)
		SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET), CB_ADDSTRING, NULL, (LPARAM) GetPresetModeString(i));

	for (i=0;i<GetPresetLentgh();i++)
	{
		if (i == nPresetIndex)
		{
			SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET), CB_SETCURSEL, i, NULL);
			break;
		}
	}

	return true;
}

bool AEncodeProperties::UpdateValueFromDlg(HWND HwndDlg)
{
	nChannelIndex      = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_CHANNELS),   CB_GETCURSEL, NULL, NULL);
	nMinBitrateIndex   = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_BITRATE),    CB_GETCURSEL, NULL, NULL);
	nMaxBitrateIndex   = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_MAXBITRATE), CB_GETCURSEL, NULL, NULL);
	nPresetIndex       = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_PRESET),     CB_GETCURSEL, NULL, NULL);
//	VbrQuality         = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_VBRQUALITY), CB_GETCURSEL, NULL, NULL);
	VbrQuality = SendMessage(GetDlgItem( HwndDlg, IDC_SLIDER_QUALITY), TBM_GETPOS , NULL, NULL);
	nSamplingFreqIndex = SendMessage(GetDlgItem( HwndDlg, IDC_COMBO_SAMPLEFREQ), CB_GETCURSEL, NULL, NULL);

	bCRC       = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_CRC),       BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bCopyright = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_COPYRIGHT), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bOriginal  = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_ORIGINAL),  BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bPrivate   = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_PRIVATE),   BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bNoBitRes  =!(SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESERVOIR), BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bVBRused   = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_VBR),       BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bXingFrame = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_XINGVBR),   BM_GETCHECK, NULL, NULL) == BST_CHECKED);
	bResample  = (SendMessage(GetDlgItem( HwndDlg, IDC_CHECK_RESAMPLE),  BM_GETCHECK, NULL, NULL) == BST_CHECKED);

	return true;
}

bool AEncodeProperties::GetVBRValue(DWORD & MaxBitrate, int & Quality, BOOL & VBRHeader, const DWORD MPEG_Version) const
{
	assert((MPEG_Version == MPEG1) || (MPEG_Version == MPEG2));
	assert(nMaxBitrateIndex < sizeof(the_Bitrates));

	if (bVBRused)
	{
		MaxBitrate = the_Bitrates[nMaxBitrateIndex];

		if (MPEG_Version == MPEG1)
			MaxBitrate = max(MaxBitrate, the_MPEG1_Bitrates[sizeof(the_MPEG1_Bitrates)/sizeof(unsigned int)-1]);
		else
			MaxBitrate = min(MaxBitrate, the_MPEG2_Bitrates[0]);

		VBRHeader = bXingFrame;
		Quality = VbrQuality;
	}

	return bVBRused;

}

void AEncodeProperties::ParamsRestore()
{
	// use these default parameters in case one is not found
	bCopyright    = true;
	bCRC          = true;
	bOriginal     = true;
	bPrivate      = true;
	bNoBitRes     = false; // enable bit reservoir
	bVBRused      = false;
	bXingFrame    = true;
	bResample     = false;
	bForceChannel = false;

	nChannelIndex = 2; // joint-stereo
	nMinBitrateIndex = 6; // 128 kbps (works for both MPEGI and II)
	nMaxBitrateIndex = 4; // 160 kbps (works for both MPEGI and II)
	nPresetIndex = 0; // None
	VbrQuality = 1; // Quite High
	nSamplingFreqIndex = 1; // 44100

	wsprintf(OutputDir,"c:\\");

	HKEY OssKey;
	if ((RegOpenKeyEx( HKEY_CURRENT_USER, "SOFTWARE\\MUKOLI\\out_lame\\Original", 0, KEY_READ , &OssKey ) == ERROR_SUCCESS) ||
		(RegOpenKeyEx( HKEY_LOCAL_MACHINE, "SOFTWARE\\MUKOLI\\out_lame\\Original", 0, KEY_READ , &OssKey ) == ERROR_SUCCESS)) {

		DWORD tmpVal;
		DWORD DSize;
		int i;

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Copyright", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bCopyright = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "CRC", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bCRC = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Original", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bOriginal = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Private", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bPrivate = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Bit Reservoir", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bNoBitRes = (tmpVal == 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Use VBR", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bVBRused = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "VBR Header", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bXingFrame = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Use Resampling", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bResample = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Force Channel", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			bForceChannel = (tmpVal != 0);

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Channel Mode", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			nChannelIndex = tmpVal;

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Bitrate", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
		{
			for (i=0;i<sizeof(the_Bitrates)/sizeof(unsigned int);i++)
			{
				if (the_Bitrates[i] == tmpVal)
				{
					nMinBitrateIndex = i;
					break;
				}
			}
		}

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Max Bitrate", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
		{
			for (i=0;i<sizeof(the_Bitrates)/sizeof(unsigned int);i++)
			{
				if (the_Bitrates[i] == tmpVal)
				{
					nMaxBitrateIndex = i;
					break;
				}
			}
		}


		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Preset", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			nPresetIndex = tmpVal;

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "VBR Quality", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
			VbrQuality = tmpVal;

		DSize = sizeof(tmpVal);
		if (RegQueryValueEx(OssKey, "Resample Frequency", NULL, NULL, (BYTE *)&tmpVal, &DSize ) == ERROR_SUCCESS)
		{
			for (i=0;i<sizeof(the_SamplingFreqs)/sizeof(unsigned int);i++)
			{
				if (the_SamplingFreqs[i] == tmpVal)
				{
					nSamplingFreqIndex = i;
					break;
				}
			}
		}

		char tmp[512];
		DSize = sizeof(tmp);
		if (RegQueryValueEx(OssKey, "Output Directory", NULL, NULL, (BYTE *)tmp, &DSize ) == ERROR_SUCCESS)
			wsprintf(OutputDir, tmp);

		RegCloseKey(OssKey); 
	}

	wsprintf(DllLocation,"plugins\\lame_enc.dll");

	if ((RegOpenKeyEx( HKEY_CURRENT_USER, "SOFTWARE\\MUKOLI\\out_lame", 0, KEY_READ , &OssKey ) == ERROR_SUCCESS) ||
		(RegOpenKeyEx( HKEY_LOCAL_MACHINE, "SOFTWARE\\MUKOLI\\out_lame", 0, KEY_READ , &OssKey ) == ERROR_SUCCESS)) {

		char tmp[512];
		DWORD DSize = sizeof(tmp);
		if (RegQueryValueEx(OssKey, "DLL Location", NULL, NULL, (BYTE *)tmp, &DSize ) == ERROR_SUCCESS)
			wsprintf(DllLocation, tmp);

		RegCloseKey(OssKey); 
	}

}

void AEncodeProperties::ParamsSave()
{

	HKEY OssKey;
	if (RegCreateKeyEx ( HKEY_LOCAL_MACHINE, "SOFTWARE\\MUKOLI\\out_lame\\Original", 0, "", REG_OPTION_NON_VOLATILE, KEY_WRITE , NULL, &OssKey, NULL ) == ERROR_SUCCESS) {
		DWORD tmpVal;

		tmpVal = bCopyright;
		if (RegSetValueEx(OssKey, "Copyright", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bCRC;
		if (RegSetValueEx(OssKey, "CRC", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bOriginal;
		if (RegSetValueEx(OssKey, "Original", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bPrivate;
		if (RegSetValueEx(OssKey, "Private", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = !bNoBitRes;
		if (RegSetValueEx(OssKey, "Bit Reservoir", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bVBRused;
		if (RegSetValueEx(OssKey, "Use VBR", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bXingFrame;
		if (RegSetValueEx(OssKey, "VBR Header", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bResample;
		if (RegSetValueEx(OssKey, "Use Resampling", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = bForceChannel;
		if (RegSetValueEx(OssKey, "Force Channel", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = nChannelIndex;
		if (RegSetValueEx(OssKey, "Channel Mode", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = the_Bitrates[nMinBitrateIndex];
		if (RegSetValueEx(OssKey, "Bitrate", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = the_Bitrates[nMaxBitrateIndex];
		if (RegSetValueEx(OssKey, "Max Bitrate", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = nPresetIndex;
		if (RegSetValueEx(OssKey, "Preset", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = VbrQuality;
		if (RegSetValueEx(OssKey, "VBR Quality", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		tmpVal = the_SamplingFreqs[nSamplingFreqIndex];
		if (RegSetValueEx(OssKey, "Resample Frequency", 0, REG_DWORD, (CONST BYTE *)&tmpVal, sizeof(tmpVal) ) != ERROR_SUCCESS)
			return;

		if (RegSetValueEx(OssKey, "Output Directory", 0, REG_SZ, (CONST BYTE *)OutputDir, strlen(OutputDir)+1 ) != ERROR_SUCCESS)
			return;

		RegCloseKey(OssKey); 
	}

	if (RegCreateKeyEx ( HKEY_LOCAL_MACHINE, "SOFTWARE\\MUKOLI\\out_lame", 0, "", REG_OPTION_NON_VOLATILE, KEY_WRITE , NULL, &OssKey, NULL ) == ERROR_SUCCESS) {

		if (RegSetValueEx(OssKey, "DLL Location", 0, REG_EXPAND_SZ, (CONST BYTE *)DllLocation, strlen(DllLocation)+1 ) != ERROR_SUCCESS)
			return;
		
		RegCloseKey(OssKey); 
	}
}

void AEncodeProperties::DisplayVbrOptions(HWND hDialog, bool bValue)
{
	if(bValue)
	{
		::SetWindowText(::GetDlgItem(hDialog,IDC_STATIC_MINBITRATE), "Min Bitrate");
	}
	else
	{
		::SetWindowText(::GetDlgItem(hDialog,IDC_STATIC_MINBITRATE), "Bitrate");
	}

	::EnableWindow(::GetDlgItem( hDialog, IDC_CHECK_XINGVBR), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_COMBO_MAXBITRATE), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_MAXBITRATE), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_SLIDER_QUALITY), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_CONFIG_QUALITY), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_VBRQUALITY), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_VBRQUALITY_LOW), bValue);

	::EnableWindow(::GetDlgItem( hDialog, IDC_STATIC_VBRQUALITY_HIGH), bValue);

}
