// ALameDLL.cpp: implementation of the ALameDLL class.
//
//////////////////////////////////////////////////////////////////////

#include "ALameDLL.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ALameDLL::ALameDLL():
	LameDLL(NULL),
	beInitStream(NULL),
	beCloseStream(NULL),
	beEncodeChunk(NULL),
	beDeinitStream(NULL),
	beWriteVBRHeader(NULL)
{
}

ALameDLL::~ALameDLL()
{
	if (LameDLL != NULL)
		FreeLibrary(LameDLL);
}

bool ALameDLL::Load(const char * DllLocation)
{
	bool result = false;

	if (LameDLL == NULL)
	{
		LameDLL = LoadLibrary(DllLocation);
	}

	if (LameDLL != NULL)
	{
		beInitStream	= (BEINITSTREAM)      GetProcAddress(LameDLL, TEXT_BEINITSTREAM);
		beCloseStream	= (BECLOSESTREAM)     GetProcAddress(LameDLL, TEXT_BECLOSESTREAM);
		beEncodeChunk	= (BEENCODECHUNK)     GetProcAddress(LameDLL, TEXT_BEENCODECHUNK);
		beDeinitStream	= (BEDEINITSTREAM)    GetProcAddress(LameDLL, TEXT_BEDEINITSTREAM);
		beWriteVBRHeader = (BEWRITEVBRHEADER) GetProcAddress(LameDLL, TEXT_BEWRITEVBRHEADER);

		if ((beInitStream != NULL) && (beCloseStream != NULL) && (beEncodeChunk != NULL) && (beDeinitStream != NULL) && (beWriteVBRHeader != NULL))
		{
			result = true;
		}
	}
	else
	{
		beInitStream     = NULL;
		beCloseStream    = NULL;
		beEncodeChunk    = NULL;
		beDeinitStream   = NULL;
		beWriteVBRHeader = NULL;
	}

	return result;
}

void ALameDLL::Free()
{
	if (LameDLL != NULL)
	{
		FreeLibrary(LameDLL);
	}

	LameDLL = NULL;
	beInitStream     = NULL;
	beCloseStream    = NULL;
	beEncodeChunk    = NULL;
	beDeinitStream   = NULL;
	beWriteVBRHeader = NULL;
}

