// ALameDLL.h: interface for the ALameDLL class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_ALAMEDLL_H__INCLUDED_)
#define _ALAMEDLL_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <windows.h>

#include "ADbg/ADbg.h"
#include "BladeMP3EncDLL.h"

class ALameDLL  
{
public:
	void Free(void);
	bool Load(const char * DllLocation);
	ALameDLL();
	virtual ~ALameDLL();

	inline BE_ERR ALameDLL::InitStream(PBE_CONFIG a, PDWORD b, PDWORD c, PHBE_STREAM d) const
	{
		if (beInitStream != NULL)
			return beInitStream(a,b,c,d);
		else
			return BE_ERR_INVALID_HANDLE;
	}

	inline BE_ERR ALameDLL::EncodeChunk(HBE_STREAM a, DWORD b, PSHORT c, PBYTE d, PDWORD e) const
	{
		if (beEncodeChunk != NULL)
			return beEncodeChunk(a,b,c,d,e);
		else
			return BE_ERR_INVALID_HANDLE;
	}


	inline BE_ERR ALameDLL::DeinitStream(HBE_STREAM a, PBYTE b, PDWORD c) const
	{
		if (beDeinitStream != NULL)
			return beDeinitStream(a,b,c);
		else
			return BE_ERR_INVALID_HANDLE;
	}

	inline BE_ERR ALameDLL::CloseStream(HBE_STREAM a) const
	{
		if (beCloseStream != NULL)
			return beCloseStream(a);
		else
			return BE_ERR_INVALID_HANDLE;
	}

	inline void ALameDLL::WriteVBRHeader(LPCSTR lpszFileName) const
	{
		if (beWriteVBRHeader != NULL)
			beWriteVBRHeader(lpszFileName);
	}

	const bool IsLoaded() const {
		return ((LameDLL != NULL) && (beInitStream != NULL) && (beCloseStream != NULL) && (beEncodeChunk != NULL) && (beDeinitStream != NULL) && (beWriteVBRHeader != NULL));
	}

//	ADbg           the_Debug;
private:
	HMODULE LameDLL;

	BEINITSTREAM     beInitStream;
	BECLOSESTREAM    beCloseStream;
	BEENCODECHUNK    beEncodeChunk;
	BEDEINITSTREAM   beDeinitStream;
	BEWRITEVBRHEADER beWriteVBRHeader;
};

#endif // !defined(_ALAMEDLL_H__INCLUDED_)
