#if !defined(STRICT)
#define STRICT
#endif // !defined(STRICT)

#include <windows.h>
#include <windowsx.h>
#include <shellapi.h>

#include "resource.h"
#include "defines.h"
#include "BladeMP3EncDLL.h"

#include "AOut.h"

#ifdef __alpha
#define PI_VER " (AXP)"
#else
#define PI_VER " (x86)"
#endif


static BOOL CALLBACK AboutProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
  )
{
	static HBRUSH hBrushStatic;
	static LOGFONT lf;  // structure for font information  
	static HFONT hfnt;
	BOOL bResult;
	static HCURSOR hcOverCursor;

	switch (uMsg) {

		case WM_COMMAND:
			UINT command;
			command = GET_WM_COMMAND_ID(wParam, lParam);
            if ((IDOK == command) || (IDCANCEL == command))
            {
				::DeleteObject(hfnt);

                EndDialog(hwndDlg, (IDOK == command));
            } 
            bResult = FALSE;
			break;

		case WM_INITDIALOG:
			HMODULE       tLameDLL;

			::GetObject(::GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &lf); 
			lf.lfUnderline = TRUE;

			hfnt = ::CreateFontIndirect(&lf);

			::SendMessage(::GetDlgItem(hwndDlg,IDC_ABOUT_HOMEPAGE), WM_SETFONT, (WPARAM) hfnt, TRUE);
			::SendMessage(::GetDlgItem(hwndDlg,IDC_ABOUT_BSD), WM_SETFONT, (WPARAM) hfnt, TRUE);

			SetDlgItemText(hwndDlg, IDC_ABOUT_VERSION, VERSION_NUMBER);
			tLameDLL = LoadLibrary(AOut::my_Properties.GetDllLocation());

			if (tLameDLL != NULL)
			{
				BEVERSION beVersion = (BEVERSION) GetProcAddress(tLameDLL, TEXT_BEVERSION);
				BE_VERSION	Version;

				if (beVersion != NULL)
				{

					beVersion(&Version);


					SetDlgItemText(hwndDlg, IDC_DLL_HOMEPAGE, Version.zHomepage);

					char toto[20];
					
					wsprintf(toto,"%u.%02u (%02u/%02u/%04u)",Version.byDLLMajorVersion, Version.byDLLMinorVersion, Version.byDay, Version.byMonth, Version.wYear);
					SetDlgItemText(hwndDlg, IDC_DLL_VERSION, toto);

					char titi[10];
					wsprintf(titi,"%u.%02u",Version.byMajorVersion, Version.byMinorVersion);
					SetDlgItemText(hwndDlg, IDC_DLL_ENGINE, titi);

					if (Version.byMMXEnabled)
						SetDlgItemText(hwndDlg, IDC_DLL_MMX, "MMX enabled");
					else
						SetDlgItemText(hwndDlg, IDC_DLL_MMX, "No MMX");

					FreeLibrary(tLameDLL);
			
					::SendMessage(::GetDlgItem(hwndDlg,IDC_DLL_HOMEPAGE), WM_SETFONT, (WPARAM) hfnt, TRUE);
				}
				else
				{
					SetDlgItemText(hwndDlg, IDC_DLL_HOMEPAGE, "Invalid DLL (please configure)");
					SetDlgItemText(hwndDlg, IDC_DLL_VERSION, "0.00");
					SetDlgItemText(hwndDlg, IDC_DLL_ENGINE, "0.00");
				}
			}
			else
			{
				SetDlgItemText(hwndDlg, IDC_DLL_HOMEPAGE, "DLL not found (please configure)");
				SetDlgItemText(hwndDlg, IDC_DLL_VERSION, "0.00");
				SetDlgItemText(hwndDlg, IDC_DLL_ENGINE, "0.00");
			}
// TODO move that
			hBrushStatic = ::CreateSolidBrush(::GetSysColor (COLOR_BTNFACE));

			hcOverCursor = ::LoadCursor(NULL,(LPCTSTR)IDC_CROSS); 

			return TRUE;
			break;

		case WM_CTLCOLORSTATIC:
			{
// TODO only if there are URLs
				if ((HWND)lParam == ::GetDlgItem(hwndDlg,IDC_DLL_HOMEPAGE) ||
					(HWND)lParam == ::GetDlgItem(hwndDlg,IDC_ABOUT_HOMEPAGE) ||
					(HWND)lParam == ::GetDlgItem(hwndDlg,IDC_ABOUT_BSD))
				{
					::SetTextColor((HDC)wParam, ::GetSysColor (COLOR_HIGHLIGHT));
					::SetBkColor((HDC)wParam, ::GetSysColor (COLOR_BTNFACE));

					return (LRESULT) hBrushStatic;
				}
				else
					return (LRESULT) NULL;
			}
			break;

		case WM_MOUSEMOVE:
			{
				POINT pnt;
				::GetCursorPos(&pnt);

				RECT rctBSD;
				::GetWindowRect( ::GetDlgItem(hwndDlg,IDC_ABOUT_BSD), &rctBSD);

				RECT rctDLLurl;
				::GetWindowRect( ::GetDlgItem(hwndDlg,IDC_DLL_HOMEPAGE), &rctDLLurl);

				RECT rctMYurl;
				::GetWindowRect( ::GetDlgItem(hwndDlg,IDC_ABOUT_HOMEPAGE), &rctMYurl);

				if (::PtInRect(&rctBSD,pnt) || ::PtInRect(&rctDLLurl,pnt) || ::PtInRect(&rctMYurl,pnt) )
				{
					::SetCursor(hcOverCursor);
				}


			}
			break;

		case WM_LBUTTONUP:
			{
				POINT pnt;
				::GetCursorPos(&pnt);

				RECT rctBSD;
				::GetWindowRect( ::GetDlgItem(hwndDlg,IDC_ABOUT_BSD), &rctBSD);

				RECT rctDLLurl;
				::GetWindowRect( ::GetDlgItem(hwndDlg,IDC_DLL_HOMEPAGE), &rctDLLurl);

				RECT rctMYurl;
				::GetWindowRect( ::GetDlgItem(hwndDlg,IDC_ABOUT_HOMEPAGE), &rctMYurl);

				if (::PtInRect(&rctBSD,pnt))
				{
					::ShellExecute(hwndDlg,"open",BSD_LICENCE_URL,NULL,"",SW_SHOWMAXIMIZED );
				}
				else if (::PtInRect(&rctDLLurl,pnt))
				{
					TCHAR Url[200];
					::GetWindowText(::GetDlgItem(hwndDlg,IDC_DLL_HOMEPAGE),Url,sizeof(Url));
					::ShellExecute(hwndDlg,"open",Url,NULL,"",SW_SHOWMAXIMIZED );
				}
				else if (::PtInRect(&rctMYurl,pnt))
				{
					TCHAR Url[200];
					::GetWindowText(::GetDlgItem(hwndDlg,IDC_ABOUT_HOMEPAGE),Url,sizeof(Url));
					::ShellExecute(hwndDlg,"open",Url,NULL,"",SW_SHOWMAXIMIZED );
				}

			}
			break;

		default:
			bResult = FALSE; // will be treated by DefWindowProc
	}
	return bResult;
}

//////////////////////////////////////////////////////////////////////
// Variables
//////////////////////////////////////////////////////////////////////


static unsigned char Output[10000];

AOut *         AOut::the_AOut = NULL;

ADbg           AOut::the_Debug;
//char           AOut::DllLocation[256] = "";
HBE_STREAM	   AOut::hbeStream;
DWORD          AOut::the_SamplesPerBlock;
//char         * AOut::the_WorkingBuffer = NULL;
char           AOut::the_WorkingBuffer[3000];
unsigned int   AOut::the_WorkingBufferUseSize = 0;
DWORD          AOut::the_SamplesUsed = 0;
DWORD          AOut::the_SamplesPerSec;
DWORD          AOut::the_Channels;
DWORD          AOut::the_MaxBuffer;
HANDLE         AOut::the_OutputFile = INVALID_HANDLE_VALUE;
ALameDLL       AOut::the_LameDLL;
AEncodeProperties AOut::my_Properties;
char           AOut::my_Filename[MAX_PATH];
#ifdef ENABLE_RAWOUTPUT
HANDLE the_RawOutputFile;
#endif // ENABLE_RAWOUTPUT

Out_Module AOut::the_Module = {
	OUT_VER,
	"Lame MP3 Writer plug-in v" VERSION_NUMBER PI_VER,
	44444,
	0, // hmainwindow
	0, // hdllinstance
	config,
	about,
	init,
	quit,
	open,
	close,
	write,
	canwrite,
	isplaying,
	pause,
	setvolume,
	setpan,
	flush,
	getoutputtime,
	getwrittentime
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AOut::AOut()
{
//	my_debug = NULL;
	
	the_Debug.setPrefix("Winamp MP3 output");

	the_AOut = this;
}

AOut::~AOut()
{
	the_AOut = NULL;
}

//////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////

Out_Module * AOut::GetOutModule()
{
	return &the_Module;
}

void AOut::config(const HWND hwndParent) { 
	the_Debug.OutPut("config");

	my_Properties.Config(the_Module.hDllInstance, hwndParent);
}

void AOut::about(const HWND hwndParent) { 
	the_Debug.OutPut("about");

	::DialogBox(the_Module.hDllInstance, MAKEINTRESOURCE(IDD_ABOUT), hwndParent, ::AboutProc);
}

void AOut::init() { 
	the_Debug.OutPut("init");
	my_Properties.ParamsRestore();
}

void AOut::quit() { 
	the_Debug.OutPut("quit");
	my_Properties.ParamsSave();
}

int  AOut::open(const int samplerate, const int numchannels, const int bitspersamp, const int bufferlenms, const int prebufferms)
{ 
	the_Debug.OutPut("open, samplerate = %d / numchannels = %d / bitspersamp =%d / bufferlenms = %d / prebufferms = %d", samplerate, numchannels, bitspersamp, bufferlenms, prebufferms);

	int result = -1;

	if (bitspersamp != 16) // only 16 bits supported at the moment
		return result;

	bool bDllLoaded;

	if (!the_LameDLL.IsLoaded())
	{

		bDllLoaded = the_LameDLL.Load(my_Properties.GetDllLocation());

	}
	else
		bDllLoaded = true;

	if (!bDllLoaded)
	{
		CloseHandle(the_OutputFile);
		the_OutputFile = INVALID_HANDLE_VALUE;
	}
	else
	{
		// Get the current played file
		HWND hwndWinamp = FindWindow("Winamp v1.x",NULL);
//#define IPC_GETLISTPOS       125
//#define IPC_GETPLAYLISTFILE  211
//#define IPC_GETPLAYLISTTITLE 212
		int index = SendMessage(hwndWinamp, WM_USER, 0, 125);
//		char *name = (char *)SendMessage(hwndWinamp, WM_USER, index, IPC_GETPLAYLISTFILE);
		char *name = (char *)SendMessage(hwndWinamp, WM_USER, index, 212);
//strrchr(name,'\\');
//the_Debug.OutPut("found Winamp window = %08X -> %s",hwndWinamp,strrchr(name,'\\')+1);
//the_Debug.OutPut("found Winamp window = %08X -> %s",hwndWinamp,name);

		char tmpFilename2[MAX_PATH];
		wsprintf( tmpFilename2, name);
		// replace forbidden chars
		replaceAllChar(tmpFilename2,'\\','-');
		replaceAllChar(tmpFilename2,'/','-');
		replaceAllChar(tmpFilename2,':','_');
		replaceAllChar(tmpFilename2,'*','x');
		replaceAllChar(tmpFilename2,'?','.');
		replaceAllChar(tmpFilename2,'"','\'');
		replaceAllChar(tmpFilename2,'<','.');
		replaceAllChar(tmpFilename2,'>','.');
		replaceAllChar(tmpFilename2,'|','_');

//		char my_Filename[MAX_PATH];
		char * dir = my_Properties.GetOutputDirectory();
		wsprintf( my_Filename, "%s%s%s.mp3",dir,(dir[strlen(dir)-1]=='\\')?"":"\\",tmpFilename2);
		
the_Debug.OutPut("my_Filename = %s",my_Filename);
//		the_OutputFile = CreateFile("c:\\out_lame.mp3", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
		the_OutputFile = CreateFile(my_Filename, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
#ifdef ENABLE_RAWOUTPUT
		the_RawOutputFile = CreateFile("c:\\temp\\out.raw", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
#endif // ENABLE_RAWOUTPUT
		
		if (the_OutputFile == INVALID_HANDLE_VALUE)
		{
			the_LameDLL.Free();

			return result;
		}


		// for the given sampling freq/bitpersamp/bitrate (config)
		//  we must compute the max latency (it will be one frame -> 576/1152 samples)

		// Init the MP3 Stream
		BE_CONFIG	beConfig;
		BE_ERR		err;
		
		memset(&beConfig,0,sizeof(beConfig));					// clear all fields

		// use the LAME config structure
		beConfig.dwConfig = BE_CONFIG_LAME;

		// this are the default settings for testcase.wav
		beConfig.format.LHV1.dwStructVersion	= 1;
		beConfig.format.LHV1.dwStructSize		= sizeof(beConfig);		
		beConfig.format.LHV1.dwSampleRate		= samplerate;							// INPUT FREQUENCY

		if (my_Properties.GetResampleMode())
			beConfig.format.LHV1.dwReSampleRate		= my_Properties.GetResampleFreq();	// RESAMPLE
		else
			beConfig.format.LHV1.dwReSampleRate		= 0;								// DON'T RESAMPLE

the_Debug.OutPut("GetResampleMode = %s / GetResampleFreq = %d / dwReSampleRate = %d",my_Properties.GetResampleMode()?"TRUE":"FALSE",my_Properties.GetResampleFreq(),beConfig.format.LHV1.dwReSampleRate);

		if (numchannels < 2)
			beConfig.format.LHV1.nMode			= BE_MP3_MODE_MONO;						// OUTPUT IN MONO
		else
		{
			beConfig.format.LHV1.nMode			= my_Properties.GetChannelModeValue();	// OUTPUT IN DESIRED MODE
		}
		
		if (beConfig.format.LHV1.dwReSampleRate == 0) // no resampling
		{
			if (samplerate < 32000)
				beConfig.format.LHV1.dwMpegVersion		= MPEG2;							// MPEG VERSION (I or II)
			else
				beConfig.format.LHV1.dwMpegVersion		= MPEG1;							// MPEG VERSION (I or II)
		}
		else
		{
			if (beConfig.format.LHV1.dwReSampleRate < 32000)
				beConfig.format.LHV1.dwMpegVersion		= MPEG2;							// MPEG VERSION (I or II)
			else
				beConfig.format.LHV1.dwMpegVersion		= MPEG1;							// MPEG VERSION (I or II)
		}

//			beConfig.format.LHV1.dwBitrate			= my_Properties.GetBitrateValue();		// MINIMUM BIT RATE
																						// MINIMUM BIT RATE
		int bitrateOK = my_Properties.GetBitrateValue(beConfig.format.LHV1.dwBitrate, beConfig.format.LHV1.dwMpegVersion);

		if (my_Properties.GetVBRUseMode())
		{
			// the VBR parameters are automatically
			bitrateOK = 0;
		}

		if (bitrateOK < 0)
		{
			TCHAR output[250];
			::LoadString(GetInstance(),IDS_STRING_BITRATE_HIGH,output,250);
			MessageBox(NULL, output,"Winamp MP3 Output",MB_OK);

			the_LameDLL.Free();
		}
		else if (bitrateOK > 0)
		{
			TCHAR output[250];
			::LoadString(GetInstance(),IDS_STRING_BITRATE_SMALL,output,250);
			MessageBox(NULL, output,"Winamp MP3 Output",MB_OK);

			the_LameDLL.Free();
		}
		else
		{


			beConfig.format.LHV1.nPreset			= my_Properties.GetPresetModeValue();	// QUALITY PRESET SETTING

			beConfig.format.LHV1.dwPsyModel			= 0;									// USE DEFAULT PSYCHOACOUSTIC MODEL 
			beConfig.format.LHV1.dwEmphasis			= 0;									// NO EMPHASIS TURNED ON
			beConfig.format.LHV1.bOriginal			= my_Properties.GetOriginalMode();		// SET ORIGINAL FLAG
			beConfig.format.LHV1.bCRC				= my_Properties.GetCRCMode();			// INSERT CRC
			beConfig.format.LHV1.bCopyright			= my_Properties.GetCopyrightMode();		// SET COPYRIGHT FLAG	
			beConfig.format.LHV1.bPrivate			= my_Properties.GetPrivateMode();		// SET PRIVATE FLAG
			beConfig.format.LHV1.bNoRes				= my_Properties.GetNoBiResMode();		// No Bit resorvoir

			beConfig.format.LHV1.bEnableVBR         = my_Properties.GetVBRValue( beConfig.format.LHV1.dwMaxBitrate, beConfig.format.LHV1.nVBRQuality, beConfig.format.LHV1.bWriteVBRHeader, beConfig.format.LHV1.dwMpegVersion);
		//	beConfig.format.LHV1.dwMaxBitrate		= 320;					// MAXIMUM BIT RATE
		//	beConfig.format.LHV1.bWriteVBRHeader	= TRUE;					// YES, WRITE THE XING VBR HEADER
		//	beConfig.format.LHV1.bEnableVBR			= TRUE;					// USE VBR
		//	beConfig.format.LHV1.nVBRQuality		= 5;					// SET VBR QUALITY
			
			
			err = the_LameDLL.InitStream(&beConfig, &the_SamplesPerBlock, &the_MaxBuffer, &hbeStream);

			// Check result
			if(err != BE_ERR_SUCCESSFUL)
			{
				the_Debug.OutPut("Error opening encoding stream (%lu)", err);
				result = -1;
			}
			else
			{
				the_Debug.OutPut("Inited stream, the_SamplesPerBlock = %d (the_MaxBuffer = %d)", the_SamplesPerBlock, the_MaxBuffer);
//				the_WorkingBuffer = new char[the_SamplesPerBlock];
				the_WorkingBufferUseSize = 0;
				SetSampleUsed(0);
				the_Channels = numchannels;
				the_SamplesPerSec = samplerate;

//				result = 0;
				result =  the_SamplesPerBlock * 1000 / (the_SamplesPerSec * the_Channels);
			}
		}
	}

	return result;
}


void AOut::close() {
	the_Debug.OutPut("close");

	DWORD EncodedSize = 0;

	the_LameDLL.DeinitStream(hbeStream, (PBYTE)Output, &EncodedSize);

	do {
		DWORD BytesWritten;
		WriteFile(the_OutputFile, Output, EncodedSize, &BytesWritten , NULL); // TODO : better handling
the_Debug.OutPut("written %d bytes in file for %d byes encoded", BytesWritten, EncodedSize);
		EncodedSize -= BytesWritten;
	} while (EncodedSize != 0);

	if (the_OutputFile != INVALID_HANDLE_VALUE)
		CloseHandle(the_OutputFile);
	the_OutputFile = INVALID_HANDLE_VALUE;
#ifdef ENABLE_RAWOUTPUT
CloseHandle(the_RawOutputFile);
#endif // ENABLE_RAWOUTPUT

	if (my_Properties.GetVBRUseMode())
	{
		the_LameDLL.WriteVBRHeader(my_Filename);
	}

	my_Filename[0] = '\0';

	the_LameDLL.CloseStream(hbeStream);

	the_LameDLL.Free();

//	if (the_WorkingBuffer != NULL)
//		delete the_WorkingBuffer;
//	the_WorkingBuffer = NULL;
	the_MaxBuffer = 0;
}

int  AOut::write(char *buf, const int len) {
	the_Debug.OutPut("write %d bytes (the_SamplesPerBlock = %d)",len,the_SamplesPerBlock);

	BE_ERR		err;

DWORD EncodedSize = 0;

	DWORD lenToUse = len;
#ifdef ENABLE_RAWOUTPUT
DWORD RawBytesWritten;
WriteFile(the_RawOutputFile, buf, len, &RawBytesWritten , NULL); // TODO : better handling
#endif // ENABLE_RAWOUTPUT

	while (lenToUse >= the_SamplesPerBlock * the_Channels/2) // 2 for 16bits<->8bits
	{
		// the_WorkingBuffer may have some remaining data from a block
		// fill the remaining part of the block to encode
		memcpy(&the_WorkingBuffer[the_WorkingBufferUseSize], &buf[len - lenToUse], (the_SamplesPerBlock * 2 / the_Channels) - the_WorkingBufferUseSize); // 2 for 16bits<->8bits

		memset(Output,0,sizeof(Output));
//the_Debug.OutPut("try to encode %d bytes (the_WorkingBuffer = 0x%08X / Output = 0x%08X), EncodedSize = %d / the_WorkingBufferUseSize = %d / lenToUse = %d / the_Channels = %d", the_SamplesPerBlock/2, the_WorkingBuffer, Output, EncodedSize, the_WorkingBufferUseSize, lenToUse, the_Channels);
/*
		if (the_Channels == 1)
		{
			char OutT[10000];
			UpMixToStereo((SHORT*)the_WorkingBuffer,(SHORT*)OutT,the_SamplesPerBlock/2);
//the_Debug.OutPut("before encoding chunck 1");
			err = the_LameDLL.EncodeChunk(hbeStream, the_SamplesPerBlock/4, (PSHORT)OutT, (PBYTE)Output, &EncodedSize); // 2 for 16bits<->8bits
		}
		else
		{
//the_Debug.OutPut("before encoding chunck 2");
			err = the_LameDLL.EncodeChunk(hbeStream, the_SamplesPerBlock/2, (PSHORT)the_WorkingBuffer, (PBYTE)Output, &EncodedSize); // 2 for 16bits<->8bits
//the_Debug.OutPut("after encoding chunck 2");
		}			
*/
		err = the_LameDLL.EncodeChunk(hbeStream, the_SamplesPerBlock*the_Channels/4, (PSHORT)the_WorkingBuffer, (PBYTE)Output, &EncodedSize); // 2 for 16bits<->8bits
		//the_Debug.OutPut("after encode chunck 1");
		if (err != BE_ERR_SUCCESSFUL)
		{
the_Debug.OutPut("error encoding");
			return -1;
		}
//the_Debug.OutPut("finished encoding %d bytes into %d bytes (output : 0x%02X %02X %02X %02X)", the_SamplesPerBlock, EncodedSize, Output[0], Output[1], Output[2], Output[3]);
		

		do {
			DWORD BytesWritten;
			WriteFile(the_OutputFile, Output, EncodedSize, &BytesWritten , NULL); // TODO : better handling
//the_Debug.OutPut("%d written bytes in file for %d byes encoded", BytesWritten, EncodedSize);
			EncodedSize -= BytesWritten;
		} while (EncodedSize != 0);
//the_Debug.OutPut("finished writing in file");

		SetSampleUsed(GetSampleUsed() + the_SamplesPerBlock);
//			lenToUse -= the_SamplesPerBlock * the_Channels / 2 ; // 2 for 16bits<->8bits
		lenToUse -= the_SamplesPerBlock * the_Channels / 2; // 2 for 16bits<->8bits
//			lenToUse -= the_SamplesPerBlock; // 2 for 16bits<->8bits
		the_WorkingBufferUseSize = 0;
	} // while

	the_WorkingBufferUseSize = lenToUse;
	memcpy(&the_WorkingBuffer[0], &buf[len - lenToUse], lenToUse);
the_Debug.OutPut("wrote %d remaining %d",len-lenToUse,lenToUse);

	return 0;
}

int  AOut::canwrite() { 
	the_Debug.OutPut("canwrite (%d)",the_MaxBuffer);
//	return 1152; // TODO : 576 is different cases
	if (the_LameDLL.IsLoaded())
		return 16*1024*1024; // TODO : 576 is different cases
	else
		return 0;
//	return the_MaxBuffer * 2 / the_Channels;
//	return the_MaxBuffer * 2 / the_Channels;
}

int  AOut::isplaying() { 
	the_Debug.OutPut("isplaying");
	return 0;
}

int  AOut::pause(const int pause) { 
	the_Debug.OutPut("pause");
	return 0;
}

void AOut::setvolume(const int volume) { 
	the_Debug.OutPut("setvolume at %d (not used yet)",volume);
	// -666 is the default volume... (nothing to do)
}

void AOut::setpan(const int pan) { 
	the_Debug.OutPut("setpan at %d (not used yet)", pan);
}

void AOut::flush(const int t) { 
	the_Debug.OutPut("flush");
}

int  AOut::getoutputtime() { 
	the_Debug.OutPut("getoutputtime");
//	return 0;
	return getwrittentime();
}

int  AOut::getwrittentime() { 
//	the_Debug.OutPut("getwrittentime");
	register DWORD up = GetSampleUsed() * 1000;
	register DWORD low = the_SamplesPerSec * the_Channels * 2;

//the_Debug.OutPut("getwrittentime = %d ms (the_SamplesUsed = %d / the_SamplesPerSec = %d / the_Channels = %d)",GetSampleUsed() * 1000 / (the_SamplesPerSec * the_Channels),GetSampleUsed(),the_SamplesPerSec, the_Channels);
//	return GetSampleUsed() * 1000 / (the_SamplesPerSec * the_Channels * 2); // 2 for 16 bits<->8bits
//the_Debug.OutPut("up = %d  / low = %d / result = %d ms", up, low, up/low);
	the_Debug.OutPut("getwrittentime = %d ms ", up/low);
	
	return up / low;

//	return 0;
}


inline void AOut::UpMixToStereo(SHORT* psData,SHORT* psOutData,DWORD dwNumSamples)
{
	int dwSample;
	for (dwSample=dwNumSamples-1;dwSample>=0;dwSample--)
	{
		psOutData[2*dwSample+0]=psData[dwSample];
		psOutData[2*dwSample+1]=psData[dwSample];
	}
}


inline void AOut::replaceAllChar(char *string, const char src, const char dst)
{
	unsigned int i;
	for (i=0;i<strlen(string);i++)
	{
		if (string[i] == src)
			string[i] = dst;
	}
}
