// AOut.h: interface for the AOut class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_AOUT_H__INCLUDED_)
#define _AOUT_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//#include "BladeMP3EncDLL.h"
#include "Out.h"

#include "ADbg/ADbg.h"
#include "AEncodeProperties.h"
#include "ALameDLL.h"

class AOut  
{
public:
//	static char DllLocation[256];
	static Out_Module * GetOutModule();

	AOut();
	virtual ~AOut();

	static void config(HWND hwndParent);
	static void about(HWND hwndParent);
	static void init();
	static void quit();
	static int  open(int samplerate, int numchannels, int bitspersamp, int bufferlenms, int prebufferms);
	static void close();
	static int  write(char *buf, int len);
	static int  canwrite();
	static int  isplaying();
	static int  pause(int pause);
	static void setvolume(int volume);
	static void setpan(int pan);
	static void flush(int t);
	static int  getoutputtime();
	static int  getwrittentime();

	static AOut * the_AOut;

	static AEncodeProperties my_Properties;

	static inline HINSTANCE GetInstance() { return the_Module.hDllInstance; }

protected:
	static inline void replaceAllChar(char * string, const char src, const char dst);
	static ADbg   the_Debug;
	static HANDLE the_OutputFile;
	static DWORD the_MaxBuffer;
	static DWORD the_Channels;
	static DWORD the_SamplesPerSec;
	static unsigned int the_WorkingBufferUseSize;
//	static char* the_WorkingBuffer;
	static char the_WorkingBuffer[];
	static DWORD the_SamplesPerBlock;
	static DWORD the_SamplesUsed;
	static Out_Module the_Module;

	
	static inline void SetSampleUsed(DWORD samples) {
		the_SamplesUsed = samples;
	}

	static inline DWORD GetSampleUsed() {
		return the_SamplesUsed;
	}

	static ALameDLL       the_LameDLL;
	static HBE_STREAM	  hbeStream;

	static char my_Filename[MAX_PATH];

	static void UpMixToStereo(SHORT* psData,SHORT* psOutData,DWORD dwNumSamples);
//	static AEncodeProperties my_Properties;
};

#endif // !defined(_AOUT_H__INCLUDED_)
