/************************************************************************
Project               : C++ parameters saving class
File version          : 0.1

BSD License post 1999 : 

Copyright (c) 2001, Steve Lhomme
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met: 

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution. 

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO 
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE. 
************************************************************************/

#if !defined(_PARAMETERS_H__INCLUDED_)
#define _PARAMETERS_H__INCLUDED_

#include <windows.h>

class AParameters
{
public:
	enum KEY_RETURNS { KEY_FOUND, LAST_KEY, KEY_ERROR };

	AParameters();
	~AParameters();

	void SetMode(const HKEY the_working_base = HKEY_LOCAL_MACHINE); // HKEY_LOCAL_MACHINE or HKEY_CURRENT_USER

	bool Attach(const char * the_base, const REGSAM the_access_mode = KEY_ALL_ACCESS);
	void Detach();

	void ResetSubKey();
	KEY_RETURNS NextSubKey(char * the_buffer, unsigned int the_buffer_size);

	void ResetValue();
	KEY_RETURNS NextSubValue(char * the_value_name, unsigned int the_value_name_size);

	// GetSubKey return NULL if the key is not found
	// when GetSubKey succeed, it should always be followed (later) by a ReleaseSubKey
	AParameters * GetSubKey(const char * the_subkey, const bool bCreateKey = false, const REGSAM the_access_mode = KEY_ALL_ACCESS);
	void ReleaseSubKey(AParameters * the_sub_key) const;

	void QueryValue(const char * the_data_name, void * the_data, unsigned long & the_buffer_size);

	bool CreateSubKey(const char * the_subkey, const bShouldNotExist = false);
	bool DeleteKey(const char * the_key);

	inline HKEY * Get_base_key() { return &my_base_key; }

protected:

	AParameters(const HKEY the_base);

	HKEY my_base_mode;
	HKEY my_base_key;
	HKEY my_working_key;

	DWORD my_subkey_current_index;

private:
};


#endif // !defined(_PARAMETERS_H__INCLUDED_)
